#include "femDOF.h"

namespace fem
{

FEM_API std::ostream &
operator<<(std::ostream &out, DOF const &obj)
{
    out << obj.dofs.name(obj);
    return out;
}

DOFs::DOFs()
{
}

void DOFs::add(std::string const &name)
{
    size_t idx = names.size();
    names.push_back(name);
    idx_by_name[name] = idx;
}

FEM_API std::ostream &
operator<<(std::ostream &out, DOFMask const &obj)
{
    bool first = true;
    for (size_t i = 0; i < obj.dofs.size(); ++i)
    {
        DOF dof = obj.dofs[i];
        if (obj & dof)
        {
            if (!first)
                out << '|';
            out << dof;
            first = false;
        }
    }
    return out;
}

FEM_API std::ostream &
operator<<(std::ostream &out, DOFs const &obj)
{
    out << "DOF types (size=" << obj.names.size() << "): " << obj.names << '\n';
    return out;
}

} // namespace fem
